##################################################################################
# First you need to load Labstory. How this is done depends on your installation.
#
# A couple of examples are given below.
# Run the two lines for your installation, and adapt as needed
#
# NOTE!!!! There can only be one instance of Labstory running per computer. R counts as
# one. So you need to close Labstory before accessing it from R, and vice versa
#
##################################################################################

#
# Linux users, using the general binary and putting it in home
#
source("/home/MYUSER/labstory/R/labstory.R")
rLabstory<-labstoryInit("/home/MYUSER/labstory")



#
# OSX users, having put labstory in /Applications/
#
source("/Applications/labstory.app/R/labstory.R")
rLabstory<-labstoryInit("/Applications/labstory.app")


#
# Windows users - here you really have to check your installation parameters
#
source("C:\\users\\MYUSER\\Local Settings\\Application Data\\Labstory\\R\\labstory.R")
rLabstory<-labstoryInit("C:\\users\\MYUSER\\Local Settings\\Application Data\\Labstory")


#
# We developing Labstory can do e.g.:
#
source("/home/mahogny/javaproj/labnote3.git/labnote/R/lib/labstory.R")
rLabstory<-labstoryInit("/home/mahogny/javaproj/labnote3.git/labnote")


##################################################################################
#
#   Overview
#
##################################################################################


### This is how you can get a list of documents
doclist <- labstoryQueryDocuments(rLabstory)


### This will load a document, by ID
doc<-labstoryLoadDocument("mahogny@areta.org-1377523495198")

### This will display all the objects (sections) in the documents.
### Note that indices are 0... (Java-style) rather than 1... (R-style)
for(i in 1:labstoryGetDocumentObjectCount(doc)){
  ob<-labstoryGetDocumentObjectByIndex(doc,i-1)
  print(sprintf("%s  -  %s  -  %s",i, ob$name, ob$getClass()$toString()))
}









