c <- function(..., recursive = FALSE)  .Primitive("c")
length <- function (x)  .Primitive("length")

NCOL <- function (x) if (length(d <- dim(x)) > 1L) d[2L] else 1L
NROW <- function (x) if (length(d <- dim(x))) d[1L] else length(x)

ncol <- function (x) dim(x)[2L]
nrow <- function (x) dim(x)[1L]

dim <- function (x)  .Primitive("dim")
dimnames <- function (x)  .Primitive("dimnames")




#####################################################################
##
colnames <- function (x, do.NULL = TRUE, prefix = "col") 
{
    if (is.data.frame(x) && do.NULL) 
        return(names(x))
    dn <- dimnames(x)
    if (!is.null(dn[[2L]])) 
        dn[[2L]]
    else {
        nc <- NCOL(x)
        if (do.NULL) 
            NULL
        else if (nc > 0L) 
            paste0(prefix, seq_len(nc))
        else character()
    }
}




#####################################################################
##
make.names <- function (names, unique = FALSE, allow_ = TRUE) 
{
    names <- .Internal(make.names(as.character(names), allow_))
    if (unique) 
        names <- make.unique(names)
    names
}




paste0 <- function (..., collapse = NULL)              .Primitive("paste0")
nzchar <- function (x)                                 .Primitive("nzchar")
nchar <- function (x, type = "chars", allowNA = FALSE) .Primitive("nchar")

seq_len <- function (length.out)                       .Primitive("seq_len")










#### example of ... last. so put it in the loop!


#####################################################################
##
sort <- function (x, decreasing = FALSE, ...) 
{
    if (!is.logical(decreasing) || length(decreasing) != 1L) 
        stop("'decreasing' must be a length-1 logical vector.\nDid you intend to set 'partial'?")
    UseMethod("sort")
}
