
#################################################################
# Absolute value
#todo code vectorized primitive
abs <- function(x){
	if(x<0) -x else x
}

#acos
#acosh
#all
#any
#atan
#atan2
#atanh
#cos
#cosh
#sin
#sinh


factorial <- function (x)  gamma(x + 1)
gamma <- function (x)  .Primitive("gamma")



#################################################################
# Square root
sqrt <- function (x)  .Primitive("sqrt")

#################################################################
# Sum
sum <- function(..., na.rm = FALSE)  .Primitive("sum")


#################################################################
# Mean
mean <- function(x, trim = 0, na.rm = FALSE, ...) {
  return(sum(x)/length(x))
}



#################################################################
# Covariance
cov <- function(x, y = NULL, use = "everything",
    method = c("pearson", "kendall", "spearman")) {

  ##  can also turn vector into matrix, and always assume having matrices
  if(is.vector(x)){
    x <- x - mean(x)
    if(is.null(y)){
      y <- x
    } else {
      y <- y - mean(y)
    }
    return( sum(x*y)/(length(x)-1) )
  } else { 
    stop("to implement")
  }
  
}


#################################################################
# Variance
var <- function (x, y = NULL, na.rm = FALSE, use) {
  cov(x,y,use)
}


#################################################################
# Standard deviance
sd <- function (x, na.rm = FALSE) {
  sqrt(var(if(is.vector(x)) x else as.double(x), na.rm = na.rm))
}  


#################################################################
# Correlation
cor <- function(x, y = NULL, use = "everything",
    method = c("pearson", "kendall", "spearman")) {
  
  if(is.vector(x)) {
    
    if(is.null(y)){
      stop("y must be given")
    } else {
      #Pearson
      dx <- x-mean(x)
      dy <- y-mean(y)
      return( sum(dx*dy)/sqrt(sum(dx*dx)*sum(dy*dy)) )
      
      #TODO should include spearman as well!
    }
  } else {
    stop("to implement")
  }
}
  

# r version has plenty of code here

